/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.223 Revision 1.419
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.223 2006/02/15 23:40:16 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.419 2013/05/21 02:57:22 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib portability 5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
13 17
14DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
15# sys-apps/shadow is needed for useradd, etc, bug #94745. 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
16 20
17DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
18 22
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 23if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 24
21# outputting to a terminal, don't wait. For compatability purposes, the argument 25# @FUNCTION: epause
22# must be an integer greater than zero. 26# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 32epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 34}
29 35
30# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
32# don't beep. 38# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 43ebeep() {
35 local n 44 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 47 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 49 echo -ne "\a"
41 sleep 1 50 sleep 1
42 done 51 done
43 fi 52 fi
44} 53}
45 54
46# This function generate linker scripts in /usr/lib for dynamic 55else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local lib libdir=$(get_libdir)
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 56
69 for lib in "${@}" ; do 57ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 59}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 60
77 See bug http://bugs.gentoo.org/4411 for more info. 61epause() {
78 */ 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 63}
80 END_LDSCRIPT 64
81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
82 done 113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
83} 119}
84 120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
85 129
86# Default directory where patches are located 130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
167# return 0
168# fi
169# done
170# eshopts_pop
171# @CODE
172eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182}
183
184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
90# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
243# -E - automatically remove empty files
244# @CODE
93EPATCH_OPTS="-g0 --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
95# and not the full path .. 249# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
97# Change the printed message for a single patch. 253# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
99# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
102# 260# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 262# arch naming style.
105EPATCH_FORCE="no" 263EPATCH_FORCE="no"
264# @VARIABLE: EPATCH_USER_EXCLUDE
265# @DEFAULT_UNSET
266# @DESCRIPTION:
267# List of patches not to apply. Note this is only file names,
268# and not the full path. Globs accepted.
106 269
107# This function is for bulk patching, or in theory for just one 270# @FUNCTION: epatch
108# or two patches. 271# @USAGE: [options] [patches] [dirs of patches]
272# @DESCRIPTION:
273# epatch is designed to greatly simplify the application of patches. It can
274# process patch files directly, or directories of patches. The patches may be
275# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276# the -p option as epatch will automatically attempt -p0 to -p5 until things
277# apply successfully.
109# 278#
110# It should work with .bz2, .gz, .zip and plain text patches. 279# If you do not specify any patches/dirs, then epatch will default to the
111# Currently all patches should be the same format. 280# directory specified by EPATCH_SOURCE.
112# 281#
113# You do not have to specify '-p' option to patch, as it will 282# Any options specified that start with a dash will be passed down to patch
114# try with -p0 to -p5 until it succeed, or fail at -p5. 283# for this specific invocation. As soon as an arg w/out a dash is found, then
284# arg processing stops.
115# 285#
116# Above EPATCH_* variables can be used to control various defaults, 286# When processing directories, epatch will apply all patches that match:
117# bug they should be left as is to ensure an ebuild can rely on 287# @CODE
118# them for. 288# if ${EPATCH_FORCE} != "yes"
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 289# ??_${ARCH}_foo.${EPATCH_SUFFIX}
290# else
291# *.${EPATCH_SUFFIX}
292# @CODE
293# The leading ?? are typically numbers used to force consistent patch ordering.
294# The arch field is used to apply patches only for the host architecture with
295# the special value of "all" means apply for everyone. Note that using values
296# other than "all" is highly discouraged -- you should apply patches all the
297# time and let architecture details be detected at configure/compile time.
125# 298#
126# For example: 299# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300# for patches to apply.
127# 301#
128# 01_all_misc-fix.patch.bz2 302# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 303epatch() {
141 _epatch_draw_line() { 304 _epatch_draw_line() {
142 local i=0 str_length="" str_out="" 305 # create a line of same length as input string
143 306 [[ -z $1 ]] && set "$(printf "%65s" '')"
144 # Handle calls that do not have args, or wc not being installed ... 307 echo "${1//?/=}"
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 } 308 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
159 local PIPE_CMD=""
160 local STDERR_TARGET="${T}/$$.out"
161 local PATCH_TARGET="${T}/$$.patch"
162 local PATCH_SUFFIX=""
163 local SINGLE_PATCH="no"
164 local x=""
165 309
166 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 310 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
167 311
168 if [ "$#" -gt 1 ] 312 # First process options. We localize the EPATCH_OPTS setting
169 then 313 # from above so that we can pass it on in the loop below with
314 # any additional values the user has specified.
315 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316 while [[ $# -gt 0 ]] ; do
317 case $1 in
318 -*) EPATCH_OPTS+=( "$1" ) ;;
319 *) break ;;
320 esac
321 shift
322 done
323
324 # Let the rest of the code process one user arg at a time --
325 # each arg may expand into multiple patches, and each arg may
326 # need to start off with the default global EPATCH_xxx values
327 if [[ $# -gt 1 ]] ; then
170 local m="" 328 local m
171 for m in "$@" ; do 329 for m in "$@" ; do
172 epatch "${m}" 330 epatch "${m}"
173 done 331 done
174 return 0 332 return 0
175 fi 333 fi
176 334
177 if [ -n "$1" -a -f "$1" ] 335 local SINGLE_PATCH="no"
178 then 336 # no args means process ${EPATCH_SOURCE}
337 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338
339 if [[ -f $1 ]] ; then
179 SINGLE_PATCH="yes" 340 SINGLE_PATCH="yes"
180 341 set -- "$1"
181 local EPATCH_SOURCE="$1" 342 # Use the suffix from the single patch (localize it); the code
343 # below will find the suffix for us
182 local EPATCH_SUFFIX="${1##*\.}" 344 local EPATCH_SUFFIX=$1
183 345
184 elif [ -n "$1" -a -d "$1" ] 346 elif [[ -d $1 ]] ; then
185 then 347 # Some people like to make dirs of patches w/out suffixes (vim)
186 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 348 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
187 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 349
350 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351 # Re-use EPATCH_SOURCE as a search dir
352 epatch "${EPATCH_SOURCE}/$1"
353 return $?
354
355 else
356 # sanity check ... if it isn't a dir or file, wtf man ?
357 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358 echo
359 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360 eerror
361 eerror " ${EPATCH_SOURCE}"
362 eerror " ( ${EPATCH_SOURCE##*/} )"
363 echo
364 die "Cannot find \$EPATCH_SOURCE!"
365 fi
366
367 # Now that we know we're actually going to apply something, merge
368 # all of the patch options back in to a single variable for below.
369 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370
371 local PIPE_CMD
372 case ${EPATCH_SUFFIX##*\.} in
373 xz) PIPE_CMD="xz -dc" ;;
374 lzma) PIPE_CMD="lzma -dc" ;;
375 bz2) PIPE_CMD="bzip2 -dc" ;;
376 gz|Z|z) PIPE_CMD="gzip -dc" ;;
377 ZIP|zip) PIPE_CMD="unzip -p" ;;
378 *) ;;
379 esac
380
381 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382
383 local x
384 for x in "$@" ; do
385 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386 # didn't match anything, ignore continue on
387 [[ ! -f ${x} ]] && continue
388
389 local patchname=${x##*/}
390
391 # Apply single patches, or forced sets of patches, or
392 # patches with ARCH dependant names.
393 # ???_arch_foo.patch
394 # Else, skip this input altogether
395 local a=${patchname#*_} # strip the ???_
396 a=${a%%_*} # strip the _foo.patch
397 if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ${EPATCH_FORCE} == "yes" || \
399 ${a} == all || \
400 ${a} == ${ARCH} ]]
188 then 401 then
189 local EPATCH_SOURCE="$1/*" 402 continue
403 fi
404
405 # Let people filter things dynamically
406 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407 # let people use globs in the exclude
408 eshopts_push -o noglob
409
410 local ex
411 for ex in ${EPATCH_EXCLUDE} ; do
412 if [[ ${patchname} == ${ex} ]] ; then
413 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414 eshopts_pop
415 continue 2
416 fi
417 done
418
419 for ex in ${EPATCH_USER_EXCLUDE} ; do
420 if [[ ${patchname} == ${ex} ]] ; then
421 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 eshopts_pop
423 continue 2
424 fi
425 done
426
427 eshopts_pop
428 fi
429
430 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432 einfo "${EPATCH_SINGLE_MSG}"
433 else
434 einfo "Applying ${patchname} ..."
435 fi
190 else 436 else
191 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 437 einfo " ${patchname} ..."
192 fi 438 fi
193 else 439
194 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 440 # most of the time, there will only be one run per unique name,
195 then 441 # but if there are more, make sure we get unique log filenames
196 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 442 local STDERR_TARGET="${T}/${patchname}.out"
197 then 443 if [[ -e ${STDERR_TARGET} ]] ; then
198 EPATCH_SOURCE="$1" 444 STDERR_TARGET="${T}/${patchname}-$$.out"
445 fi
446
447 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448
449 # Decompress the patch if need be
450 local count=0
451 local PATCH_TARGET
452 if [[ -n ${PIPE_CMD} ]] ; then
453 PATCH_TARGET="${T}/$$.patch"
454 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455
456 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457 echo
458 eerror "Could not extract patch!"
459 #die "Could not extract patch!"
460 count=5
461 break
199 fi 462 fi
463 else
464 PATCH_TARGET=${x}
465 fi
200 466
467 # Check for absolute paths in patches. If sandbox is disabled,
468 # people could (accidently) patch files in the root filesystem.
469 # Or trigger other unpleasantries #237667. So disallow -p0 on
470 # such patches.
471 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472 if [[ -n ${abs_paths} ]] ; then
473 count=1
474 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475 fi
476 # Similar reason, but with relative paths.
477 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478 if [[ -n ${rel_paths} ]] ; then
201 echo 479 echo
202 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 480 eerror "Rejected Patch: ${patchname} !"
481 eerror " ( ${PATCH_TARGET} )"
203 eerror 482 eerror
204 eerror " ${EPATCH_SOURCE}" 483 eerror "Your patch uses relative paths '../':"
205 eerror " ( ${EPATCH_SOURCE##*/} )" 484 eerror "${rel_paths}"
206 echo 485 echo
207 die "Cannot find \$EPATCH_SOURCE!" 486 die "you need to fix the relative paths in patch"
208 fi
209
210 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
211 fi 487 fi
212 488
213 case ${EPATCH_SUFFIX##*\.} in 489 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
214 bz2) 490 local patch_cmd
215 PIPE_CMD="bzip2 -dc" 491 # Handle aliased patch command #404447 #461568
216 PATCH_SUFFIX="bz2" 492 local patch="patch"
217 ;; 493 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
218 gz|Z|z) 494 while [[ ${count} -lt 5 ]] ; do
219 PIPE_CMD="gzip -dc" 495 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
220 PATCH_SUFFIX="gz"
221 ;;
222 ZIP|zip)
223 PIPE_CMD="unzip -p"
224 PATCH_SUFFIX="zip"
225 ;;
226 *)
227 PIPE_CMD="cat"
228 PATCH_SUFFIX="patch"
229 ;;
230 esac
231 496
232 if [ "${SINGLE_PATCH}" = "no" ] 497 # Generate some useful debug info ...
233 then 498 (
234 einfo "${EPATCH_MULTI_MSG}" 499 _epatch_draw_line "***** ${patchname} *****"
235 fi 500 echo
236 for x in ${EPATCH_SOURCE} 501 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
237 do 502 echo
238 # New ARCH dependant patch naming scheme ... 503 _epatch_draw_line "***** ${patchname} *****"
239 # 504 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
240 # ???_arch_foo.patch 505 ret=$?
241 # 506 echo
242 if [ -f ${x} ] && \ 507 echo "patch program exited with status ${ret}"
243 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \ 508 exit ${ret}
244 [ "${EPATCH_FORCE}" = "yes" ]) 509 ) >> "${STDERR_TARGET}"
245 then
246 local count=0
247 local popts="${EPATCH_OPTS}"
248 local patchname=${x##*/}
249 510
250 if [ -n "${EPATCH_EXCLUDE}" ] 511 if [ $? -eq 0 ] ; then
251 then 512 (
252 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ] 513 _epatch_draw_line "***** ${patchname} *****"
253 then 514 echo
254 continue 515 echo "ACTUALLY APPLYING ${patchname} ..."
516 echo
517 _epatch_draw_line "***** ${patchname} *****"
518 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
519 ret=$?
520 echo
521 echo "patch program exited with status ${ret}"
522 exit ${ret}
523 ) >> "${STDERR_TARGET}"
524
525 if [ $? -ne 0 ] ; then
526 echo
527 eerror "A dry-run of patch command succeeded, but actually"
528 eerror "applying the patch failed!"
529 #die "Real world sux compared to the dreamworld!"
530 count=5
255 fi 531 fi
532 break
256 fi 533 fi
257 534
258 if [ "${SINGLE_PATCH}" = "yes" ] 535 : $(( count++ ))
259 then
260 if [ -n "${EPATCH_SINGLE_MSG}" ]
261 then
262 einfo "${EPATCH_SINGLE_MSG}"
263 else
264 einfo "Applying ${patchname} ..."
265 fi
266 else
267 einfo " ${patchname} ..."
268 fi
269
270 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272
273 # Allow for prefix to differ ... im lazy, so shoot me :/
274 while [ "${count}" -lt 5 ]
275 do
276 # Generate some useful debug info ...
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if [ "${PATCH_SUFFIX}" != "patch" ]
281 then
282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284 else
285 PATCH_TARGET="${x}"
286 fi
287
288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293
294 if [ "${PATCH_SUFFIX}" != "patch" ]
295 then
296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
297 then
298 echo
299 eerror "Could not extract patch!"
300 #die "Could not extract patch!"
301 count=5
302 break
303 fi
304 fi
305
306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
307 then
308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
316
317 if [ "$?" -ne 0 ]
318 then
319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
320 echo
321 eerror "A dry-run of patch command succeeded, but actually"
322 eerror "applying the patch failed!"
323 #die "Real world sux compared to the dreamworld!"
324 count=5
325 fi
326
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
328
329 break
330 fi
331
332 count=$((count + 1))
333 done 536 done
334 537
335 if [ "${PATCH_SUFFIX}" != "patch" ] 538 # if we had to decompress the patch, delete the temp one
336 then 539 if [[ -n ${PIPE_CMD} ]] ; then
337 rm -f ${PATCH_TARGET} 540 rm -f "${PATCH_TARGET}"
338 fi 541 fi
339 542
340 if [ "${count}" -eq 5 ] 543 if [[ ${count} -ge 5 ]] ; then
341 then
342 echo 544 echo
343 eerror "Failed Patch: ${patchname} !" 545 eerror "Failed Patch: ${patchname} !"
344 eerror " ( ${PATCH_TARGET} )" 546 eerror " ( ${PATCH_TARGET} )"
345 eerror 547 eerror
346 eerror "Include in your bugreport the contents of:" 548 eerror "Include in your bugreport the contents of:"
347 eerror 549 eerror
348 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 550 eerror " ${STDERR_TARGET}"
349 echo 551 echo
350 die "Failed Patch: ${patchname}!" 552 die "Failed Patch: ${patchname}!"
351 fi 553 fi
352 554
353 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 555 # if everything worked, delete the full debug patch log
556 rm -f "${STDERR_TARGET}"
354 557
558 # then log away the exact stuff for people to review later
559 cat <<-EOF >> "${T}/epatch.log"
560 PATCH: ${x}
561 CMD: ${patch_cmd}
562 PWD: ${PWD}
563
564 EOF
355 eend 0 565 eend 0
356 fi
357 done 566 done
358 if [ "${SINGLE_PATCH}" = "no" ] 567
359 then 568 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
360 einfo "Done with patching" 569 : # everything worked
570}
571
572# @FUNCTION: epatch_user
573# @USAGE:
574# @DESCRIPTION:
575# Applies user-provided patches to the source tree. The patches are
576# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
577# of these three directories to exist will be the one to use, ignoring
578# any more general directories which might exist as well. They must end
579# in ".patch" to be applied.
580#
581# User patches are intended for quick testing of patches without ebuild
582# modifications, as well as for permanent customizations a user might
583# desire. Obviously, there can be no official support for arbitrarily
584# patched ebuilds. So whenever a build log in a bug report mentions that
585# user patches were applied, the user should be asked to reproduce the
586# problem without these.
587#
588# Not all ebuilds do call this function, so placing patches in the
589# stated directory might or might not work, depending on the package and
590# the eclasses it inherits and uses. It is safe to call the function
591# repeatedly, so it is always possible to add a call at the ebuild
592# level. The first call is the time when the patches will be
593# applied.
594#
595# Ideally, this function should be called after gentoo-specific patches
596# have been applied, so that their code can be modified as well, but
597# before calls to e.g. eautoreconf, as the user patches might affect
598# autotool input files as well.
599epatch_user() {
600 [[ $# -ne 0 ]] && die "epatch_user takes no options"
601
602 # Allow multiple calls to this function; ignore all but the first
603 local applied="${T}/epatch_user.log"
604 [[ -e ${applied} ]] && return 2
605
606 # don't clobber any EPATCH vars that the parent might want
607 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
608 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
609 EPATCH_SOURCE=${base}/${CTARGET}/${check}
610 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
611 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
612 if [[ -d ${EPATCH_SOURCE} ]] ; then
613 EPATCH_SOURCE=${EPATCH_SOURCE} \
614 EPATCH_SUFFIX="patch" \
615 EPATCH_FORCE="yes" \
616 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
617 epatch
618 echo "${EPATCH_SOURCE}" > "${applied}"
619 return 0
361 fi 620 fi
621 done
622 echo "none" > "${applied}"
623 return 1
362} 624}
363 625
626# @FUNCTION: emktemp
627# @USAGE: [temp dir]
628# @DESCRIPTION:
364# Cheap replacement for when debianutils (and thus mktemp) 629# Cheap replacement for when debianutils (and thus mktemp)
365# does not exist on the users system 630# does not exist on the users system.
366# vapier@gentoo.org
367#
368# Takes just 1 optional parameter (the directory to create tmpfile in)
369emktemp() { 631emktemp() {
370 local exe="touch" 632 local exe="touch"
371 [[ $1 == -d ]] && exe="mkdir" && shift 633 [[ $1 == -d ]] && exe="mkdir" && shift
372 local topdir=$1 634 local topdir=$1
373 635
375 [[ -z ${T} ]] \ 637 [[ -z ${T} ]] \
376 && topdir="/tmp" \ 638 && topdir="/tmp" \
377 || topdir=${T} 639 || topdir=${T}
378 fi 640 fi
379 641
380 if [[ -z $(type -p mktemp) ]] ; then 642 if ! type -P mktemp > /dev/null ; then
643 # system lacks `mktemp` so we have to fake it
381 local tmp=/ 644 local tmp=/
382 while [[ -e ${tmp} ]] ; do 645 while [[ -e ${tmp} ]] ; do
383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 646 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
384 done 647 done
385 ${exe} "${tmp}" || ${exe} -p "${tmp}" 648 ${exe} "${tmp}" || ${exe} -p "${tmp}"
386 echo "${tmp}" 649 echo "${tmp}"
387 else 650 else
651 # the args here will give slightly wierd names on BSD,
652 # but should produce a usable file on all userlands
388 if [[ ${exe} == "touch" ]] ; then 653 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \ 654 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
390 && exe="-p" \
391 || exe="-t"
392 else 655 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && exe="-d" \
395 || exe="-dt"
396 fi
397 TMPDIR="${topdir}" mktemp ${exe} tmp 656 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
398 fi
399}
400
401# Small wrapper for getent (Linux), nidump (Mac OS X),
402# and pw (FreeBSD) used in enewuser()/enewgroup()
403# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
404# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
405#
406# egetent(database, key)
407egetent() {
408 case ${CHOST} in
409 *-darwin*)
410 case "$2" in
411 *[!0-9]*) # Non numeric
412 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
413 ;;
414 *) # Numeric
415 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
416 ;;
417 esac
418 ;;
419 *-freebsd*|*-dragonfly*)
420 local opts action="user"
421 [[ $1 == "passwd" ]] || action="group"
422
423 # lookup by uid/gid
424 if [[ $2 == [[:digit:]]* ]] ; then
425 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
426 fi
427
428 pw show ${action} ${opts} "$2" -q
429 ;;
430 *-netbsd*|*-openbsd*)
431 grep "$2:\*:" /etc/$1
432 ;;
433 *)
434 type -p nscd >& /dev/null && nscd -i "$1"
435 getent "$1" "$2"
436 ;;
437 esac
438}
439
440# Simplify/standardize adding users to the system
441# vapier@gentoo.org
442#
443# enewuser(username, uid, shell, homedir, groups, extra options)
444#
445# Default values if you do not specify any:
446# username: REQUIRED !
447# uid: next available (see useradd(8))
448# note: pass -1 to get default behavior
449# shell: /bin/false
450# homedir: /dev/null
451# groups: none
452# extra: comment of 'added by portage for ${PN}'
453enewuser() {
454 # get the username
455 local euser=$1; shift
456 if [[ -z ${euser} ]] ; then
457 eerror "No username specified !"
458 die "Cannot call enewuser without a username"
459 fi
460
461 # lets see if the username already exists
462 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
463 return 0
464 fi
465 einfo "Adding user '${euser}' to your system ..."
466
467 # options to pass to useradd
468 local opts=
469
470 # handle uid
471 local euid=$1; shift
472 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
473 if [[ ${euid} -gt 0 ]] ; then
474 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
475 euid="next"
476 fi 657 fi
477 else
478 eerror "Userid given but is not greater than 0 !"
479 die "${euid} is not a valid UID"
480 fi 658 fi
481 else
482 euid="next"
483 fi
484 if [[ ${euid} == "next" ]] ; then
485 for euid in $(seq 101 999) ; do
486 [[ -z $(egetent passwd ${euid}) ]] && break
487 done
488 fi
489 opts="${opts} -u ${euid}"
490 einfo " - Userid: ${euid}"
491
492 # handle shell
493 local eshell=$1; shift
494 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
495 if [[ ! -e ${ROOT}${eshell} ]] ; then
496 eerror "A shell was specified but it does not exist !"
497 die "${eshell} does not exist in ${ROOT}"
498 fi
499 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
500 eerror "Do not specify ${eshell} yourself, use -1"
501 die "Pass '-1' as the shell parameter"
502 fi
503 else
504 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
505 [[ -x ${ROOT}${shell} ]] && break
506 done
507
508 if [[ ${shell} == "/dev/null" ]] ; then
509 eerror "Unable to identify the shell to use"
510 die "Unable to identify the shell to use"
511 fi
512
513 eshell=${shell}
514 fi
515 einfo " - Shell: ${eshell}"
516 opts="${opts} -s ${eshell}"
517
518 # handle homedir
519 local ehome=$1; shift
520 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
521 ehome="/dev/null"
522 fi
523 einfo " - Home: ${ehome}"
524 opts="${opts} -d ${ehome}"
525
526 # handle groups
527 local egroups=$1; shift
528 if [[ ! -z ${egroups} ]] ; then
529 local oldifs=${IFS}
530 local defgroup="" exgroups=""
531
532 export IFS=","
533 for g in ${egroups} ; do
534 export IFS=${oldifs}
535 if [[ -z $(egetent group "${g}") ]] ; then
536 eerror "You must add group ${g} to the system first"
537 die "${g} is not a valid GID"
538 fi
539 if [[ -z ${defgroup} ]] ; then
540 defgroup=${g}
541 else
542 exgroups="${exgroups},${g}"
543 fi
544 export IFS=","
545 done
546 export IFS=${oldifs}
547
548 opts="${opts} -g ${defgroup}"
549 if [[ ! -z ${exgroups} ]] ; then
550 opts="${opts} -G ${exgroups:1}"
551 fi
552 else
553 egroups="(none)"
554 fi
555 einfo " - Groups: ${egroups}"
556
557 # handle extra and add the user
558 local oldsandbox=${SANDBOX_ON}
559 export SANDBOX_ON="0"
560 case ${CHOST} in
561 *-darwin*)
562 ### Make the user
563 if [[ -z $@ ]] ; then
564 dscl . create /users/${euser} uid ${euid}
565 dscl . create /users/${euser} shell ${eshell}
566 dscl . create /users/${euser} home ${ehome}
567 dscl . create /users/${euser} realname "added by portage for ${PN}"
568 ### Add the user to the groups specified
569 local oldifs=${IFS}
570 export IFS=","
571 for g in ${egroups} ; do
572 dscl . merge /groups/${g} users ${euser}
573 done
574 export IFS=${oldifs}
575 else
576 einfo "Extra options are not supported on Darwin yet"
577 einfo "Please report the ebuild along with the info below"
578 einfo "eextra: $@"
579 die "Required function missing"
580 fi
581 ;;
582 *-freebsd*|*-dragonfly*)
583 if [[ -z $@ ]] ; then
584 pw useradd ${euser} ${opts} \
585 -c "added by portage for ${PN}" \
586 die "enewuser failed"
587 else
588 einfo " - Extra: $@"
589 pw useradd ${euser} ${opts} \
590 "$@" || die "enewuser failed"
591 fi
592 ;;
593
594 *-netbsd*)
595 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} || die "enewuser failed"
597 else
598 einfo " - Extra: $@"
599 useradd ${opts} ${euser} "$@" || die "enewuser failed"
600 fi
601 ;;
602
603 *-openbsd*)
604 if [[ -z $@ ]] ; then
605 useradd -u ${euid} -s ${eshell} \
606 -d ${ehome} -c "Added by portage for ${PN}" \
607 -g ${egroups} ${euser} || die "enewuser failed"
608 else
609 einfo " - Extra: $@"
610 useradd -u ${euid} -s ${eshell} \
611 -d ${ehome} -c "Added by portage for ${PN}" \
612 -g ${egroups} ${euser} "$@" || die "enewuser failed"
613 fi
614 ;;
615
616 *)
617 if [[ -z $@ ]] ; then
618 useradd ${opts} ${euser} \
619 -c "added by portage for ${PN}" \
620 || die "enewuser failed"
621 else
622 einfo " - Extra: $@"
623 useradd ${opts} ${euser} "$@" \
624 || die "enewuser failed"
625 fi
626 ;;
627 esac
628
629 if [[ ! -e ${ROOT}/${ehome} ]] ; then
630 einfo " - Creating ${ehome} in ${ROOT}"
631 mkdir -p "${ROOT}/${ehome}"
632 chown ${euser} "${ROOT}/${ehome}"
633 chmod 755 "${ROOT}/${ehome}"
634 fi
635
636 export SANDBOX_ON=${oldsandbox}
637} 659}
638 660
639# Simplify/standardize adding groups to the system 661# @FUNCTION: edos2unix
640# vapier@gentoo.org 662# @USAGE: <file> [more files ...]
641# 663# @DESCRIPTION:
642# enewgroup(group, gid) 664# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
643# 665# to remove all of these text utilities from DEPEND variables because this
644# Default values if you do not specify any: 666# is a script based solution. Just give it a list of files to convert and
645# groupname: REQUIRED ! 667# they will all be changed from the DOS CRLF format to the UNIX LF format.
646# gid: next available (see groupadd(8))
647# extra: none
648enewgroup() {
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 668edos2unix() {
752 for f in "$@" 669 [[ $# -eq 0 ]] && return 0
753 do 670 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 671}
758 672
759 673# @FUNCTION: make_desktop_entry
760############################################################## 674# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# START: Handle .desktop files and menu entries # 675# @DESCRIPTION:
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765
766# Make a desktop file ! 676# Make a .desktop file.
767# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today !
769# 677#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 678# @CODE
771#
772# binary: what binary does the app run with ? 679# binary: what command does the app run with ?
773# name: the name that will show up in the menu 680# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 681# icon: the icon to use in the menu entry
775# this can be relative (to /usr/share/pixmaps) or 682# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 683# a full path to an icon
777# type: what kind of application is this ? for categories: 684# type: what kind of application is this?
778# http://www.freedesktop.org/Standards/desktop-entry-spec 685# for categories:
779# path: if your app needs to startup in a specific dir 686# http://standards.freedesktop.org/menu-spec/latest/apa.html
687# if unset, function tries to guess from package's category
688# fields: extra fields to append to the desktop file; a printf string
689# @CODE
780make_desktop_entry() { 690make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 691 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 692
783 local exec=${1} 693 local exec=${1}
784 local name=${2:-${PN}} 694 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 695 local icon=${3:-${PN}}
786 local type=${4} 696 local type=${4}
787 local path=${5} 697 local fields=${5}
788 698
789 if [[ -z ${type} ]] ; then 699 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 700 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 701 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 702 case ${catmaj} in
793 app) 703 app)
794 case ${catmin} in 704 case ${catmin} in
705 accessibility) type="Utility;Accessibility";;
795 admin) type=System;; 706 admin) type=System;;
707 antivirus) type=System;;
708 arch) type="Utility;Archiving";;
709 backup) type="Utility;Archiving";;
796 cdr) type=DiscBurning;; 710 cdr) type="AudioVideo;DiscBurning";;
797 dicts) type=Dictionary;; 711 dicts) type="Office;Dictionary";;
712 doc) type=Documentation;;
798 editors) type=TextEditor;; 713 editors) type="Utility;TextEditor";;
799 emacs) type=TextEditor;; 714 emacs) type="Development;TextEditor";;
800 emulation) type=Emulator;; 715 emulation) type="System;Emulator";;
801 laptop) type=HardwareSettings;; 716 laptop) type="Settings;HardwareSettings";;
802 office) type=Office;; 717 office) type=Office;;
718 pda) type="Office;PDA";;
803 vim) type=TextEditor;; 719 vim) type="Development;TextEditor";;
804 xemacs) type=TextEditor;; 720 xemacs) type="Development;TextEditor";;
805 *) type=;;
806 esac 721 esac
807 ;; 722 ;;
808 723
809 dev) 724 dev)
810 type="Development" 725 type="Development"
811 ;; 726 ;;
812 727
813 games) 728 games)
814 case ${catmin} in 729 case ${catmin} in
815 action) type=ActionGame;; 730 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 731 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 732 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 733 emulation) type=Emulator;;
734 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 735 puzzle) type=LogicGame;;
736 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 737 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 738 simulation) type=Simulation;;
824 sports) type=SportsGame;; 739 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 740 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 741 esac
828 type="Game;${type}" 742 type="Game;${type}"
829 ;; 743 ;;
830 744
745 gnome)
746 type="Gnome;GTK"
747 ;;
748
749 kde)
750 type="KDE;Qt"
751 ;;
752
831 mail) 753 mail)
832 type="Network;Email" 754 type="Network;Email"
833 ;; 755 ;;
834 756
835 media) 757 media)
836 case ${catmin} in 758 case ${catmin} in
759 gfx)
837 gfx) type=Graphics;; 760 type=Graphics
761 ;;
762 *)
763 case ${catmin} in
838 radio) type=Tuner;; 764 radio) type=Tuner;;
839 sound) type=Audio;; 765 sound) type=Audio;;
840 tv) type=TV;; 766 tv) type=TV;;
841 video) type=Video;; 767 video) type=Video;;
842 *) type=;; 768 esac
769 type="AudioVideo;${type}"
770 ;;
843 esac 771 esac
844 type="AudioVideo;${type}"
845 ;; 772 ;;
846 773
847 net) 774 net)
848 case ${catmin} in 775 case ${catmin} in
849 dialup) type=Dialup;; 776 dialup) type=Dialup;;
852 irc) type=IRCClient;; 779 irc) type=IRCClient;;
853 mail) type=Email;; 780 mail) type=Email;;
854 news) type=News;; 781 news) type=News;;
855 nntp) type=News;; 782 nntp) type=News;;
856 p2p) type=FileTransfer;; 783 p2p) type=FileTransfer;;
857 *) type=;; 784 voip) type=Telephony;;
858 esac 785 esac
859 type="Network;${type}" 786 type="Network;${type}"
860 ;; 787 ;;
861 788
862 sci) 789 sci)
863 case ${catmin} in 790 case ${catmin} in
864 astro*) type=Astronomy;; 791 astro*) type=Astronomy;;
865 bio*) type=Biology;; 792 bio*) type=Biology;;
866 calc*) type=Calculator;; 793 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 794 chem*) type=Chemistry;;
795 elec*) type=Electronics;;
868 geo*) type=Geology;; 796 geo*) type=Geology;;
869 math*) type=Math;; 797 math*) type=Math;;
870 *) type=;; 798 physics) type=Physics;;
799 visual*) type=DataVisualization;;
871 esac 800 esac
872 type="Science;${type}" 801 type="Education;Science;${type}"
802 ;;
803
804 sys)
805 type="System"
873 ;; 806 ;;
874 807
875 www) 808 www)
876 case ${catmin} in 809 case ${catmin} in
877 client) type=WebBrowser;; 810 client) type=WebBrowser;;
878 *) type=;;
879 esac 811 esac
880 type="Network" 812 type="Network;${type}"
881 ;; 813 ;;
882 814
883 *) 815 *)
884 type= 816 type=
885 ;; 817 ;;
888 if [ "${SLOT}" == "0" ] ; then 820 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 821 local desktop_name="${PN}"
890 else 822 else
891 local desktop_name="${PN}-${SLOT}" 823 local desktop_name="${PN}-${SLOT}"
892 fi 824 fi
825 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 826 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
894 827
828 # Don't append another ";" when a valid category value is provided.
829 type=${type%;}${type:+;}
830
831 eshopts_push -s extglob
832 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
833 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
834 ewarn "allowed in .desktop files if the value is not an absolute path."
835 icon=${icon%.@(xpm|png|svg)}
836 fi
837 eshopts_pop
838
839 cat <<-EOF > "${desktop}"
895echo "[Desktop Entry] 840 [Desktop Entry]
896Encoding=UTF-8
897Version=0.9.2
898Name=${name} 841 Name=${name}
899Type=Application 842 Type=Application
900Comment=${DESCRIPTION} 843 Comment=${DESCRIPTION}
901Exec=${exec} 844 Exec=${exec}
902Path=${path} 845 TryExec=${exec%% *}
903Icon=${icon} 846 Icon=${icon}
904Categories=Application;${type};" > "${desktop}" 847 Categories=${type}
848 EOF
849
850 if [[ ${fields:-=} != *=* ]] ; then
851 # 5th arg used to be value to Path=
852 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
853 fields="Path=${fields}"
854 fi
855 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
905 856
906 ( 857 (
907 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
908 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
909 insinto /usr/share/applications 860 insinto /usr/share/applications
910 doins "${desktop}" 861 doins "${desktop}"
911 ) 862 ) || die "installing desktop file failed"
912} 863}
913 864
914# Make a GDM/KDM Session file 865# @FUNCTION: validate_desktop_entries
915# 866# @USAGE: [directories]
916# make_desktop_entry(<title>, <command>) 867# @MAINTAINER:
917# title: File to execute to start the Window Manager 868# Carsten Lohrke <carlo@gentoo.org>
918# command: Name of the Window Manager 869# @DESCRIPTION:
870# Validate desktop entries using desktop-file-utils
871validate_desktop_entries() {
872 if [[ -x /usr/bin/desktop-file-validate ]] ; then
873 einfo "Checking desktop entry validity"
874 local directories=""
875 for d in /usr/share/applications $@ ; do
876 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
877 done
878 if [[ -n ${directories} ]] ; then
879 for FILE in $(find ${directories} -name "*\.desktop" \
880 -not -path '*.hidden*' | sort -u 2>/dev/null)
881 do
882 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
883 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
884 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
885 done
886 fi
887 echo ""
888 else
889 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
890 fi
891}
919 892
893# @FUNCTION: make_session_desktop
894# @USAGE: <title> <command> [command args...]
895# @DESCRIPTION:
896# Make a GDM/KDM Session file. The title is the file to execute to start the
897# Window Manager. The command is the name of the Window Manager.
898#
899# You can set the name of the file via the ${wm} variable.
920make_session_desktop() { 900make_session_desktop() {
921 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 901 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
922 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 902 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
923 903
924 local title=$1 904 local title=$1
925 local command=$2 905 local command=$2
926 local desktop=${T}/${wm}.desktop 906 local desktop=${T}/${wm:-${PN}}.desktop
907 shift 2
927 908
909 cat <<-EOF > "${desktop}"
928echo "[Desktop Entry] 910 [Desktop Entry]
929Encoding=UTF-8
930Name=${title} 911 Name=${title}
931Comment=This session logs you into ${title} 912 Comment=This session logs you into ${title}
932Exec=${command} 913 Exec=${command} $*
933TryExec=${command} 914 TryExec=${command}
934Type=Application" > "${desktop}" 915 Type=XSession
916 EOF
935 917
918 (
919 # wrap the env here so that the 'insinto' call
920 # doesn't corrupt the env of the caller
936 insinto /usr/share/xsessions 921 insinto /usr/share/xsessions
937 doins "${desktop}" 922 doins "${desktop}"
923 )
938} 924}
939 925
926# @FUNCTION: domenu
927# @USAGE: <menus>
928# @DESCRIPTION:
929# Install the list of .desktop menu files into the appropriate directory
930# (/usr/share/applications).
940domenu() { 931domenu() {
932 (
933 # wrap the env here so that the 'insinto' call
934 # doesn't corrupt the env of the caller
941 local i j 935 local i j ret=0
942 insinto /usr/share/applications 936 insinto /usr/share/applications
943 for i in "$@" ; do 937 for i in "$@" ; do
944 if [[ -f ${i} ]] ; then 938 if [[ -f ${i} ]] ; then
945 doins "${i}" 939 doins "${i}"
940 ((ret+=$?))
946 elif [[ -d ${i} ]] ; then 941 elif [[ -d ${i} ]] ; then
947 for j in "${i}"/*.desktop ; do 942 for j in "${i}"/*.desktop ; do
948 doins "${j}" 943 doins "${j}"
944 ((ret+=$?))
949 done 945 done
946 else
947 ((++ret))
950 fi 948 fi
951 done 949 done
950 exit ${ret}
951 )
952} 952}
953
954# @FUNCTION: newmenu
955# @USAGE: <menu> <newname>
956# @DESCRIPTION:
957# Like all other new* functions, install the specified menu as newname.
953newmenu() { 958newmenu() {
959 (
960 # wrap the env here so that the 'insinto' call
961 # doesn't corrupt the env of the caller
954 insinto /usr/share/applications 962 insinto /usr/share/applications
955 newins "$1" "$2" 963 newins "$@"
964 )
956} 965}
957 966
958doicon() { 967# @FUNCTION: _iconins
959 local i j 968# @INTERNAL
960 insinto /usr/share/pixmaps 969# @DESCRIPTION:
961 for i in "$@" ; do 970# function for use in doicon and newicon
962 if [[ -f ${i} ]] ; then 971_iconins() {
963 doins "${i}" 972 (
964 elif [[ -d ${i} ]] ; then 973 # wrap the env here so that the 'insinto' call
965 for j in "${i}"/*.png ; do 974 # doesn't corrupt the env of the caller
966 doins "${j}" 975 local funcname=$1; shift
967 done 976 local size dir
968 fi 977 local context=apps
969 done 978 local theme=hicolor
970}
971newicon() {
972 insinto /usr/share/pixmaps
973 newins "$1" "$2"
974}
975 979
976############################################################## 980 while [[ $# -gt 0 ]] ; do
977# END: Handle .desktop files and menu entries # 981 case $1 in
978############################################################## 982 -s|--size)
979 983 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
980 984 size=${2%%x*}
981# for internal use only (unpack_pdv and unpack_makeself)
982find_unpackable_file() {
983 local src=$1
984 if [[ -z ${src} ]] ; then
985 src=${DISTDIR}/${A}
986 else
987 if [[ -e ${DISTDIR}/${src} ]] ; then
988 src=${DISTDIR}/${src}
989 elif [[ -e ${PWD}/${src} ]] ; then
990 src=${PWD}/${src}
991 elif [[ -e ${src} ]] ; then
992 src=${src}
993 fi
994 fi
995 [[ ! -e ${src} ]] && return 1
996 echo "${src}"
997}
998
999# Unpack those pesky pdv generated files ...
1000# They're self-unpacking programs with the binary package stuffed in
1001# the middle of the archive. Valve seems to use it a lot ... too bad
1002# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1003#
1004# Usage: unpack_pdv [file to unpack] [size of off_t]
1005# - you have to specify the off_t size ... i have no idea how to extract that
1006# information out of the binary executable myself. basically you pass in
1007# the size of the off_t type (in bytes) on the machine that built the pdv
1008# archive. one way to determine this is by running the following commands:
1009# strings <pdv archive> | grep lseek
1010# strace -elseek <pdv archive>
1011# basically look for the first lseek command (we do the strings/grep because
1012# sometimes the function call is _llseek or something) and steal the 2nd
1013# parameter. here is an example:
1014# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1015# lseek
1016# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1017# lseek(3, -4, SEEK_END) = 2981250
1018# thus we would pass in the value of '4' as the second parameter.
1019unpack_pdv() {
1020 local src=$(find_unpackable_file $1)
1021 local sizeoff_t=$2
1022
1023 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1025
1026 local shrtsrc=$(basename "${src}")
1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1030
1031 # grab metadata for debug reasons
1032 local metafile="$(emktemp)"
1033 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1034
1035 # rip out the final file name from the metadata
1036 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1037 datafile="`basename ${datafile}`"
1038
1039 # now lets uncompress/untar the file if need be
1040 local tmpfile="$(emktemp)"
1041 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1042
1043 local iscompressed="`file -b ${tmpfile}`"
1044 if [ "${iscompressed:0:8}" == "compress" ] ; then
1045 iscompressed=1
1046 mv ${tmpfile}{,.Z}
1047 gunzip ${tmpfile}
1048 else
1049 iscompressed=0
1050 fi
1051 local istar="`file -b ${tmpfile}`"
1052 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1053 istar=1
1054 else
1055 istar=0
1056 fi
1057
1058 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1059 #dd if=${src} ibs=${metaskip} count=1 \
1060 # | dd ibs=${tailskip} skip=1 \
1061 # | gzip -dc \
1062 # > ${datafile}
1063 if [ ${iscompressed} -eq 1 ] ; then
1064 if [ ${istar} -eq 1 ] ; then
1065 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1066 | head -c $((${metaskip}-${tailskip})) \
1067 | tar -xzf -
1068 else 985 else
1069 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \ 986 size=${2}
1070 | head -c $((${metaskip}-${tailskip})) \
1071 | gzip -dc \
1072 > ${datafile}
1073 fi 987 fi
1074 else
1075 if [ ${istar} -eq 1 ] ; then
1076 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1077 | head -c $((${metaskip}-${tailskip})) \
1078 | tar --no-same-owner -xf -
1079 else
1080 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1081 | head -c $((${metaskip}-${tailskip})) \
1082 > ${datafile}
1083 fi
1084 fi
1085 true
1086 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1088}
1089
1090# Unpack those pesky makeself generated files ...
1091# They're shell scripts with the binary package tagged onto
1092# the end of the archive. Loki utilized the format as does
1093# many other game companies.
1094#
1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1096# - If the file is not specified then unpack will utilize ${A}.
1097# - If the offset is not specified then we will attempt to extract
1098# the proper offset from the script itself.
1099unpack_makeself() {
1100 local src_input=${1:-${A}}
1101 local src=$(find_unpackable_file "${src_input}")
1102 local skip=$2
1103 local exe=$3
1104
1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1106
1107 local shrtsrc=$(basename "${src}")
1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1109 if [[ -z ${skip} ]] ; then
1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1111 local skip=0
1112 exe=tail
1113 case ${ver} in 988 case ${size} in
1114 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 989 16|22|24|32|36|48|64|72|96|128|192|256)
1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 990 size=${size}x${size};;
1116 ;; 991 scalable)
1117 2.0|2.0.1)
1118 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1119 ;;
1120 2.1.1)
1121 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1122 let skip="skip + 1"
1123 ;;
1124 2.1.2)
1125 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1126 let skip="skip + 1"
1127 ;;
1128 2.1.3)
1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1130 let skip="skip + 1"
1131 ;;
1132 2.1.4|2.1.5)
1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1134 skip=$(head -n ${skip} "${src}" | wc -c)
1135 exe="dd"
1136 ;; 992 ;;
1137 *) 993 *)
1138 eerror "I'm sorry, but I was unable to support the Makeself file." 994 eerror "${size} is an unsupported icon size!"
1139 eerror "The version I detected was '${ver}'." 995 exit 1;;
1140 eerror "Please file a bug about the file ${shrtsrc} at"
1141 eerror "http://bugs.gentoo.org/ so that support can be added."
1142 die "makeself version '${ver}' not supported"
1143 ;;
1144 esac 996 esac
1145 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 997 shift 2;;
1146 fi 998 -t|--theme)
1147 case ${exe} in 999 theme=${2}
1148 tail) exe="tail -n +${skip} '${src}'";; 1000 shift 2;;
1149 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1001 -c|--context)
1150 *) die "makeself cant handle exe '${exe}'" 1002 context=${2}
1151 esac 1003 shift 2;;
1152
1153 # lets grab the first few bytes of the file to figure out what kind of archive it is
1154 local tmpfile="$(emktemp)"
1155 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1156 local filetype="$(file -b "${tmpfile}")"
1157 case ${filetype} in
1158 *tar\ archive)
1159 eval ${exe} | tar --no-same-owner -xf -
1160 ;;
1161 bzip2*)
1162 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1163 ;;
1164 gzip*)
1165 eval ${exe} | tar --no-same-owner -xzf -
1166 ;;
1167 compress*)
1168 eval ${exe} | gunzip | tar --no-same-owner -xf -
1169 ;;
1170 *) 1004 *)
1171 eerror "Unknown filetype \"${filetype}\" ?"
1172 false
1173 ;;
1174 esac
1175 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1176}
1177
1178# Display a license for user to accept.
1179#
1180# Usage: check_license [license]
1181# - If the file is not specified then ${LICENSE} is used.
1182check_license() {
1183 local lic=$1
1184 if [ -z "${lic}" ] ; then
1185 lic="${PORTDIR}/licenses/${LICENSE}"
1186 else
1187 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1188 lic="${PORTDIR}/licenses/${lic}"
1189 elif [ -e "${PWD}/${lic}" ] ; then
1190 lic="${PWD}/${lic}"
1191 elif [ -e "${lic}" ] ; then
1192 lic="${lic}"
1193 fi
1194 fi
1195 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1196 local l="`basename ${lic}`"
1197
1198 # here is where we check for the licenses the user already
1199 # accepted ... if we don't find a match, we make the user accept
1200 local shopts=$-
1201 local alic
1202 set -o noglob #so that bash doesn't expand "*"
1203 for alic in ${ACCEPT_LICENSE} ; do
1204 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1205 set +o noglob; set -${shopts} #reset old shell opts
1206 return 0
1207 fi
1208 done
1209 set +o noglob; set -$shopts #reset old shell opts
1210
1211 local licmsg="$(emktemp)"
1212 cat << EOF > ${licmsg}
1213**********************************************************
1214The following license outlines the terms of use of this
1215package. You MUST accept this license for installation to
1216continue. When you are done viewing, hit 'q'. If you
1217CTRL+C out of this, the install will not run!
1218**********************************************************
1219
1220EOF
1221 cat ${lic} >> ${licmsg}
1222 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1223 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1224 read alic
1225 case ${alic} in
1226 yes|Yes|y|Y)
1227 return 0
1228 ;;
1229 *)
1230 echo;echo;echo
1231 eerror "You MUST accept the license to continue! Exiting!"
1232 die "Failed to accept license"
1233 ;;
1234 esac
1235}
1236
1237# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1238# the whole 'non-interactive' policy, but damnit I want CD support !
1239#
1240# with these cdrom functions we handle all the user interaction and
1241# standardize everything. all you have to do is call cdrom_get_cds()
1242# and when the function returns, you can assume that the cd has been
1243# found at CDROM_ROOT.
1244#
1245# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1246# etc... if you want to give the cds better names, then just export
1247# the CDROM_NAME_X variables before calling cdrom_get_cds().
1248#
1249# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1250#
1251# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1252# - this will attempt to locate a cd based upon a file that is on
1253# the cd ... the more files you give this function, the more cds
1254# the cdrom functions will handle
1255cdrom_get_cds() {
1256 # first we figure out how many cds we're dealing with by
1257 # the # of files they gave us
1258 local cdcnt=0
1259 local f=
1260 for f in "$@" ; do
1261 ((++cdcnt))
1262 export CDROM_CHECK_${cdcnt}="$f"
1263 done
1264 export CDROM_TOTAL_CDS=${cdcnt}
1265 export CDROM_CURRENT_CD=1
1266
1267 # now we see if the user gave use CD_ROOT ...
1268 # if they did, let's just believe them that it's correct
1269 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1270 local var=
1271 cdcnt=0
1272 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1273 ((++cdcnt))
1274 var="CD_ROOT_${cdcnt}"
1275 [[ -z ${!var} ]] && var="CD_ROOT"
1276 if [[ -z ${!var} ]] ; then 1005 if [[ -z ${size} ]] ; then
1277 eerror "You must either use just the CD_ROOT" 1006 insinto /usr/share/pixmaps
1278 eerror "or specify ALL the CD_ROOT_X variables." 1007 else
1279 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1008 insinto /usr/share/icons/${theme}/${size}/${context}
1280 die "could not locate CD_ROOT_${cdcnt}"
1281 fi 1009 fi
1282 done
1283 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1284 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1285 export CDROM_SET=-1
1286 for f in ${CDROM_CHECK_1//:/ } ; do
1287 ((++CDROM_SET))
1288 [[ -e ${CD_ROOT}/${f} ]] && break
1289 done
1290 export CDROM_MATCH=${f}
1291 return
1292 fi
1293 1010
1294 # User didn't help us out so lets make sure they know they can 1011 if [[ ${funcname} == doicon ]] ; then
1295 # simplify the whole process ...
1296 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1297 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1298 echo
1299 einfo "If you do not have the CD, but have the data files"
1300 einfo "mounted somewhere on your filesystem, just export"
1301 einfo "the variable CD_ROOT so that it points to the"
1302 einfo "directory containing the files."
1303 echo
1304 einfo "For example:"
1305 einfo "export CD_ROOT=/mnt/cdrom"
1306 echo
1307 else
1308 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1309 cdcnt=0
1310 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1311 ((++cdcnt))
1312 var="CDROM_NAME_${cdcnt}"
1313 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1314 done
1315 echo
1316 einfo "If you do not have the CDs, but have the data files"
1317 einfo "mounted somewhere on your filesystem, just export"
1318 einfo "the following variables so they point to the right place:"
1319 einfon ""
1320 cdcnt=0
1321 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1322 ((++cdcnt))
1323 echo -n " CD_ROOT_${cdcnt}"
1324 done
1325 echo
1326 einfo "Or, if you have all the files in the same place, or"
1327 einfo "you only have one cdrom, you can export CD_ROOT"
1328 einfo "and that place will be used as the same data source"
1329 einfo "for all the CDs."
1330 echo
1331 einfo "For example:"
1332 einfo "export CD_ROOT_1=/mnt/cdrom"
1333 echo
1334 fi
1335
1336 export CDROM_SET=""
1337 export CDROM_CURRENT_CD=0
1338 cdrom_load_next_cd
1339}
1340
1341# this is only used when you need access to more than one cd.
1342# when you have finished using the first cd, just call this function.
1343# when it returns, CDROM_ROOT will be pointing to the second cd.
1344# remember, you can only go forward in the cd chain, you can't go back.
1345cdrom_load_next_cd() {
1346 local var
1347 ((++CDROM_CURRENT_CD))
1348
1349 unset CDROM_ROOT
1350 var=CD_ROOT_${CDROM_CURRENT_CD}
1351 [[ -z ${!var} ]] && var="CD_ROOT"
1352 if [[ -z ${!var} ]] ; then 1012 if [[ -f $1 ]] ; then
1353 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1013 doins "${1}"
1354 _cdrom_locate_file_on_cd ${!var} 1014 elif [[ -d $1 ]] ; then
1355 else 1015 shopt -s nullglob
1356 export CDROM_ROOT=${!var} 1016 doins "${1}"/*.{png,svg}
1357 fi 1017 shopt -u nullglob
1358
1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1360}
1361
1362# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1363# functions. this should *never* be called from an ebuild.
1364# all it does is try to locate a give file on a cd ... if the cd isn't
1365# found, then a message asking for the user to insert the cdrom will be
1366# displayed and we'll hang out here until:
1367# (1) the file is found on a mounted cdrom
1368# (2) the user hits CTRL+C
1369_cdrom_locate_file_on_cd() {
1370 local mline=""
1371 local showedmsg=0
1372
1373 while [[ -z ${CDROM_ROOT} ]] ; do
1374 local i=0
1375 local -a cdset=(${*//:/ })
1376 if [[ -n ${CDROM_SET} ]] ; then
1377 cdset=(${cdset[${CDROM_SET}]})
1378 fi
1379
1380 while [[ -n ${cdset[${i}]} ]] ; do
1381 local dir=$(dirname ${cdset[${i}]})
1382 local file=$(basename ${cdset[${i}]})
1383
1384 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1385 [[ -d ${mline}/${dir} ]] || continue
1386 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1387 export CDROM_ROOT=${mline}
1388 export CDROM_SET=${i}
1389 export CDROM_MATCH=${cdset[${i}]}
1390 return
1391 fi
1392 done
1393
1394 ((++i))
1395 done
1396
1397 echo
1398 if [[ ${showedmsg} -eq 0 ]] ; then
1399 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1400 if [[ -z ${CDROM_NAME} ]] ; then
1401 einfo "Please insert+mount the cdrom for ${PN} now !"
1402 else 1018 else
1403 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 1019 eerror "${1} is not a valid file/directory!"
1020 exit 1
1404 fi 1021 fi
1405 else 1022 else
1406 if [[ -z ${CDROM_NAME_1} ]] ; then 1023 break
1407 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1408 else
1409 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1410 einfo "Please insert+mount the ${!var} cdrom now !"
1411 fi
1412 fi 1024 fi
1413 showedmsg=1 1025 shift 1;;
1414 fi 1026 esac
1415 einfo "Press return to scan for the cd again"
1416 einfo "or hit CTRL+C to abort the emerge."
1417 echo
1418 einfo "If you are having trouble with the detection"
1419 einfo "of your CD, it is possible that you do not have"
1420 einfo "Joliet support enabled in your kernel. Please"
1421 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1422 read || die "something is screwed with your system"
1423 done 1027 done
1028 if [[ ${funcname} == newicon ]] ; then
1029 newins "$@"
1030 fi
1031 ) || die
1424} 1032}
1425 1033
1034# @FUNCTION: doicon
1035# @USAGE: [options] <icons>
1036# @DESCRIPTION:
1037# Install icon into the icon directory /usr/share/icons or into
1038# /usr/share/pixmaps if "--size" is not set.
1039# This is useful in conjunction with creating desktop/menu files.
1040#
1041# @CODE
1042# options:
1043# -s, --size
1044# !!! must specify to install into /usr/share/icons/... !!!
1045# size of the icon, like 48 or 48x48
1046# supported icon sizes are:
1047# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1048# -c, --context
1049# defaults to "apps"
1050# -t, --theme
1051# defaults to "hicolor"
1052#
1053# icons: list of icons
1054#
1055# example 1: doicon foobar.png fuqbar.svg suckbar.png
1056# results in: insinto /usr/share/pixmaps
1057# doins foobar.png fuqbar.svg suckbar.png
1058#
1059# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1060# results in: insinto /usr/share/icons/hicolor/48x48/apps
1061# doins foobar.png fuqbar.png blobbar.png
1062# @CODE
1063doicon() {
1064 _iconins ${FUNCNAME} "$@"
1065}
1066
1067# @FUNCTION: newicon
1068# @USAGE: [options] <icon> <newname>
1069# @DESCRIPTION:
1070# Like doicon, install the specified icon as newname.
1071#
1072# @CODE
1073# example 1: newicon foobar.png NEWNAME.png
1074# results in: insinto /usr/share/pixmaps
1075# newins foobar.png NEWNAME.png
1076#
1077# example 2: newicon -s 48 foobar.png NEWNAME.png
1078# results in: insinto /usr/share/icons/hicolor/48x48/apps
1079# newins foobar.png NEWNAME.png
1080# @CODE
1081newicon() {
1082 _iconins ${FUNCNAME} "$@"
1083}
1084
1085# @FUNCTION: strip-linguas
1086# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1087# @DESCRIPTION:
1426# Make sure that LINGUAS only contains languages that 1088# Make sure that LINGUAS only contains languages that
1427# a package can support 1089# a package can support. The first form allows you to
1428# 1090# specify a list of LINGUAS. The -i builds a list of po
1429# usage: strip-linguas <allow LINGUAS> 1091# files found in all the directories and uses the
1430# strip-linguas -i <directories of .po files> 1092# intersection of the lists. The -u builds a list of po
1431# strip-linguas -u <directories of .po files> 1093# files found in all the directories and uses the union
1432# 1094# of the lists.
1433# The first form allows you to specify a list of LINGUAS.
1434# The -i builds a list of po files found in all the
1435# directories and uses the intersection of the lists.
1436# The -u builds a list of po files found in all the
1437# directories and uses the union of the lists.
1438strip-linguas() { 1095strip-linguas() {
1439 local ls newls 1096 local ls newls nols
1440 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1097 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1441 local op=$1; shift 1098 local op=$1; shift
1442 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1099 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1443 local d f 1100 local d f
1444 for d in "$@" ; do 1101 for d in "$@" ; do
1445 if [[ ${op} == "-u" ]] ; then 1102 if [[ ${op} == "-u" ]] ; then
1446 newls=${ls} 1103 newls=${ls}
1447 else 1104 else
1448 newls="" 1105 newls=""
1449 fi 1106 fi
1450 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1107 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1451 if [[ ${op} == "-i" ]] ; then 1108 if [[ ${op} == "-i" ]] ; then
1452 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1109 has ${f} ${ls} && newls="${newls} ${f}"
1453 else 1110 else
1454 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1111 has ${f} ${ls} || newls="${newls} ${f}"
1455 fi 1112 fi
1456 done 1113 done
1457 ls=${newls} 1114 ls=${newls}
1458 done 1115 done
1459 ls=${ls//.po}
1460 else 1116 else
1461 ls=$@ 1117 ls="$@"
1462 fi 1118 fi
1463 1119
1464 ls=" ${ls} " 1120 nols=""
1465 newls="" 1121 newls=""
1466 for f in ${LINGUAS} ; do 1122 for f in ${LINGUAS} ; do
1467 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1123 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1124 newls="${newls} ${f}"
1469 else 1125 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1126 nols="${nols} ${f}"
1471 fi 1127 fi
1472 done 1128 done
1473 if [[ -z ${newls} ]] ; then 1129 [[ -n ${nols} ]] \
1474 export LINGUAS="" 1130 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1475 else
1476 export LINGUAS=${newls:1} 1131 export LINGUAS=${newls:1}
1477 fi
1478} 1132}
1479 1133
1480# moved from kernel.eclass since they are generally useful outside of 1134# @FUNCTION: preserve_old_lib
1481# kernel.eclass -iggy (20041002) 1135# @USAGE: <libs to preserve> [more libs]
1482 1136# @DESCRIPTION:
1483# the following functions are useful in kernel module ebuilds, etc.
1484# for an example see ivtv or drbd ebuilds
1485
1486# set's ARCH to match what the kernel expects
1487set_arch_to_kernel() {
1488 i=10
1489 while ((i--)) ; do
1490 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1491 done
1492 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1493 case ${ARCH} in
1494 x86) export ARCH="i386";;
1495 amd64) export ARCH="x86_64";;
1496 hppa) export ARCH="parisc";;
1497 mips) export ARCH="mips";;
1498 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1499 *) export ARCH="${ARCH}";;
1500 esac
1501}
1502
1503# set's ARCH back to what portage expects
1504set_arch_to_portage() {
1505 i=10
1506 while ((i--)) ; do
1507 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1508 done
1509 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1510}
1511
1512# Jeremy Huddleston <eradicator@gentoo.org>:
1513# preserve_old_lib /path/to/libblah.so.0
1514# preserve_old_lib_notify /path/to/libblah.so.0
1515#
1516# These functions are useful when a lib in your package changes --soname. Such 1137# These functions are useful when a lib in your package changes ABI SONAME.
1517# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1138# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1518# would break packages that link against it. Most people get around this 1139# would break packages that link against it. Most people get around this
1519# by using the portage SLOT mechanism, but that is not always a relevant 1140# by using the portage SLOT mechanism, but that is not always a relevant
1520# solution, so instead you can add the following to your ebuilds: 1141# solution, so instead you can call this from pkg_preinst. See also the
1521# 1142# preserve_old_lib_notify function.
1522# src_install() {
1523# ...
1524# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1525# ...
1526# }
1527#
1528# pkg_postinst() {
1529# ...
1530# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1531# ...
1532# }
1533
1534preserve_old_lib() { 1143preserve_old_lib() {
1535 LIB=$1 1144 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1145 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1146 die "Invalid preserve_old_lib() usage"
1147 fi
1148 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1536 1149
1537 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1150 # let portage worry about it
1538 SONAME=`basename ${LIB}` 1151 has preserve-libs ${FEATURES} && return 0
1539 DIRNAME=`dirname ${LIB}`
1540 1152
1541 dodir ${DIRNAME} 1153 local lib dir
1542 cp ${ROOT}${LIB} ${D}${DIRNAME} 1154 for lib in "$@" ; do
1155 [[ -e ${ROOT}/${lib} ]] || continue
1156 dir=${lib%/*}
1157 dodir ${dir} || die "dodir ${dir} failed"
1158 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1543 touch ${D}${LIB} 1159 touch "${D}"/${lib}
1544 fi 1160 done
1545} 1161}
1546 1162
1163# @FUNCTION: preserve_old_lib_notify
1164# @USAGE: <libs to notify> [more libs]
1165# @DESCRIPTION:
1166# Spit helpful messages about the libraries preserved by preserve_old_lib.
1547preserve_old_lib_notify() { 1167preserve_old_lib_notify() {
1548 LIB=$1 1168 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1169 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1170 die "Invalid preserve_old_lib_notify() usage"
1171 fi
1549 1172
1550 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1173 # let portage worry about it
1551 SONAME=`basename ${LIB}` 1174 has preserve-libs ${FEATURES} && return 0
1552 1175
1176 local lib notice=0
1177 for lib in "$@" ; do
1178 [[ -e ${ROOT}/${lib} ]] || continue
1179 if [[ ${notice} -eq 0 ]] ; then
1180 notice=1
1553 ewarn "An old version of an installed library was detected on your system." 1181 ewarn "Old versions of installed libraries were detected on your system."
1554 ewarn "In order to avoid breaking packages that link against it, this older version" 1182 ewarn "In order to avoid breaking packages that depend on these old libs,"
1555 ewarn "is not being removed. In order to make full use of this newer version," 1183 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1556 ewarn "you will need to execute the following command:" 1184 ewarn "in order to remove these old dependencies. If you do not have this"
1557 ewarn " revdep-rebuild --soname ${SONAME}" 1185 ewarn "helper program, simply emerge the 'gentoolkit' package."
1558 ewarn 1186 ewarn
1559 ewarn "After doing that, you can safely remove ${LIB}"
1560 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1561 fi 1187 fi
1188 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1189 done
1562} 1190}
1563 1191
1564# Hack for people to figure out if a package was built with 1192# @FUNCTION: built_with_use
1565# certain USE flags 1193# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1194# @DESCRIPTION:
1566# 1195#
1567# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1196# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1568# ex: built_with_use xchat gtk2
1569# 1197#
1570# Flags: -a all USE flags should be utilized 1198# A temporary hack until portage properly supports DEPENDing on USE
1571# -o at least one USE flag should be utilized 1199# flags being enabled in packages. This will check to see if the specified
1572# Note: the default flag is '-a' 1200# DEPEND atom was built with the specified list of USE flags. The
1201# --missing option controls the behavior if called on a package that does
1202# not actually support the defined USE flags (aka listed in IUSE).
1203# The default is to abort (call die). The -a and -o flags control
1204# the requirements of the USE flags. They correspond to "and" and "or"
1205# logic. So the -a flag means all listed USE flags must be enabled
1206# while the -o flag means at least one of the listed IUSE flags must be
1207# enabled. The --hidden option is really for internal use only as it
1208# means the USE flag we're checking is hidden expanded, so it won't be found
1209# in IUSE like normal USE flags.
1210#
1211# Remember that this function isn't terribly intelligent so order of optional
1212# flags matter.
1573built_with_use() { 1213built_with_use() {
1214 local hidden="no"
1215 if [[ $1 == "--hidden" ]] ; then
1216 hidden="yes"
1217 shift
1218 fi
1219
1220 local missing_action="die"
1221 if [[ $1 == "--missing" ]] ; then
1222 missing_action=$2
1223 shift ; shift
1224 case ${missing_action} in
1225 true|false|die) ;;
1226 *) die "unknown action '${missing_action}'";;
1227 esac
1228 fi
1229
1574 local opt=$1 1230 local opt=$1
1575 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1231 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1576 1232
1577 local PKG=$(best_version $1) 1233 local PKG=$(best_version $1)
1234 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1578 shift 1235 shift
1579 1236
1580 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1237 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1238 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1581 1239
1582 # if the USE file doesnt exist, assume the $PKG is either 1240 # if the IUSE file doesn't exist, the read will error out, we need to handle
1583 # injected or package.provided 1241 # this gracefully
1584 [[ ! -e ${USEFILE} ]] && return 0 1242 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1243 case ${missing_action} in
1244 true) return 0;;
1245 false) return 1;;
1246 die) die "Unable to determine what USE flags $PKG was built with";;
1247 esac
1248 fi
1249
1250 if [[ ${hidden} == "no" ]] ; then
1251 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1252 # Don't check USE_EXPAND #147237
1253 local expand
1254 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1255 if [[ $1 == ${expand}_* ]] ; then
1256 expand=""
1257 break
1258 fi
1259 done
1260 if [[ -n ${expand} ]] ; then
1261 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1262 case ${missing_action} in
1263 true) return 0;;
1264 false) return 1;;
1265 die) die "$PKG does not actually support the $1 USE flag!";;
1266 esac
1267 fi
1268 fi
1269 fi
1585 1270
1586 local USE_BUILT=$(<${USEFILE}) 1271 local USE_BUILT=$(<${USEFILE})
1587 while [[ $# -gt 0 ]] ; do 1272 while [[ $# -gt 0 ]] ; do
1588 if [[ ${opt} = "-o" ]] ; then 1273 if [[ ${opt} = "-o" ]] ; then
1589 has $1 ${USE_BUILT} && return 0 1274 has $1 ${USE_BUILT} && return 0
1593 shift 1278 shift
1594 done 1279 done
1595 [[ ${opt} = "-a" ]] 1280 [[ ${opt} = "-a" ]]
1596} 1281}
1597 1282
1283# @FUNCTION: epunt_cxx
1284# @USAGE: [dir to scan]
1285# @DESCRIPTION:
1598# Many configure scripts wrongly bail when a C++ compiler 1286# Many configure scripts wrongly bail when a C++ compiler could not be
1599# could not be detected. #73450 1287# detected. If dir is not specified, then it defaults to ${S}.
1288#
1289# http://bugs.gentoo.org/73450
1600epunt_cxx() { 1290epunt_cxx() {
1601 local dir=$1 1291 local dir=$1
1602 [[ -z ${dir} ]] && dir=${S} 1292 [[ -z ${dir} ]] && dir=${S}
1603 ebegin "Removing useless C++ checks" 1293 ebegin "Removing useless C++ checks"
1604 local f 1294 local f p any_found
1605 for f in $(find ${dir} -name configure) ; do 1295 while IFS= read -r -d '' f; do
1606 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1296 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1297 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1298 any_found=1
1299 break
1300 fi
1607 done 1301 done
1302 done < <(find "${dir}" -name configure -print0)
1303
1304 if [[ -z ${any_found} ]]; then
1305 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1306 fi
1608 eend 0 1307 eend 0
1609} 1308}
1610 1309
1611# dopamd <file> [more files] 1310# @FUNCTION: make_wrapper
1612# 1311# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1613# Install pam auth config file in /etc/pam.d 1312# @DESCRIPTION:
1614dopamd() { 1313# Create a shell wrapper script named wrapper in installpath
1615 [[ -z $1 ]] && die "dopamd requires at least one argument" 1314# (defaults to the bindir) to execute target (default of wrapper) by
1616 1315# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1617 use pam || return 0 1316# libpaths followed by optionally changing directory to chdir.
1618
1619 INSDESTTREE=/etc/pam.d \
1620 doins "$@" || die "failed to install $@"
1621}
1622# newpamd <old name> <new name>
1623#
1624# Install pam file <old name> as <new name> in /etc/pam.d
1625newpamd() {
1626 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1627
1628 use pam || return 0
1629
1630 INSDESTTREE=/etc/pam.d \
1631 newins "$1" "$2" || die "failed to install $1 as $2"
1632}
1633
1634# make a wrapper script ...
1635# NOTE: this was originally games_make_wrapper, but I noticed other places where
1636# this could be used, so I have moved it here and made it not games-specific
1637# -- wolf31o2
1638# $1 == wrapper name
1639# $2 == binary to run
1640# $3 == directory to chdir before running binary
1641# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1642# $5 == path for wrapper
1643make_wrapper() { 1317make_wrapper() {
1644 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1318 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1645 local tmpwrapper=$(emktemp) 1319 local tmpwrapper=$(emktemp)
1320
1321 (
1322 echo '#!/bin/sh'
1323 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1324 if [[ -n ${libdir} ]] ; then
1325 cat <<-EOF
1326 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1327 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1328 else
1329 export LD_LIBRARY_PATH="${libdir}"
1330 fi
1331 EOF
1332 fi
1646 # We don't want to quote ${bin} so that people can pass complex 1333 # We don't want to quote ${bin} so that people can pass complex
1647 # things as $bin ... "./someprog --args" 1334 # things as ${bin} ... "./someprog --args"
1335 printf 'exec %s "$@"\n' "${bin}"
1648 cat << EOF > "${tmpwrapper}" 1336 ) > "${tmpwrapper}"
1649#!/bin/sh
1650cd "${chdir:-.}"
1651if [ -n "${libdir}" ] ; then
1652 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1653 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1654 else
1655 export LD_LIBRARY_PATH="${libdir}"
1656 fi
1657fi
1658exec ${bin} "\$@"
1659EOF
1660 chmod go+rx "${tmpwrapper}" 1337 chmod go+rx "${tmpwrapper}"
1338
1661 if [[ -n ${path} ]] ; then 1339 if [[ -n ${path} ]] ; then
1340 (
1662 exeinto "${path}" 1341 exeinto "${path}"
1663 newexe "${tmpwrapper}" "${wrapper}" 1342 newexe "${tmpwrapper}" "${wrapper}"
1343 ) || die
1664 else 1344 else
1665 newbin "${tmpwrapper}" "${wrapper}" 1345 newbin "${tmpwrapper}" "${wrapper}" || die
1346 fi
1347}
1348
1349# @FUNCTION: path_exists
1350# @USAGE: [-a|-o] <paths>
1351# @DESCRIPTION:
1352# Check if the specified paths exist. Works for all types of paths
1353# (files/dirs/etc...). The -a and -o flags control the requirements
1354# of the paths. They correspond to "and" and "or" logic. So the -a
1355# flag means all the paths must exist while the -o flag means at least
1356# one of the paths must exist. The default behavior is "and". If no
1357# paths are specified, then the return value is "false".
1358path_exists() {
1359 local opt=$1
1360 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1361
1362 # no paths -> return false
1363 # same behavior as: [[ -e "" ]]
1364 [[ $# -eq 0 ]] && return 1
1365
1366 local p r=0
1367 for p in "$@" ; do
1368 [[ -e ${p} ]]
1369 : $(( r += $? ))
1370 done
1371
1372 case ${opt} in
1373 -a) return $(( r != 0 )) ;;
1374 -o) return $(( r == $# )) ;;
1375 esac
1376}
1377
1378# @FUNCTION: in_iuse
1379# @USAGE: <flag>
1380# @DESCRIPTION:
1381# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1382# as necessary.
1383#
1384# Note that this function should not be used in the global scope.
1385in_iuse() {
1386 debug-print-function ${FUNCNAME} "${@}"
1387 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1388
1389 local flag=${1}
1390 local liuse=( ${IUSE} )
1391
1392 has "${flag}" "${liuse[@]#[+-]}"
1393}
1394
1395# @FUNCTION: use_if_iuse
1396# @USAGE: <flag>
1397# @DESCRIPTION:
1398# Return true if the given flag is in USE and IUSE.
1399#
1400# Note that this function should not be used in the global scope.
1401use_if_iuse() {
1402 in_iuse $1 || return 1
1403 use $1
1404}
1405
1406# @FUNCTION: usex
1407# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1408# @DESCRIPTION:
1409# Proxy to declare usex for package managers or EAPIs that do not provide it
1410# and use the package manager implementation when available (i.e. EAPI >= 5).
1411# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1412# otherwise echo [false output][false suffix] (defaults to "no").
1413if has "${EAPI:-0}" 0 1 2 3 4; then
1414 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1415fi
1416
1417# @FUNCTION: prune_libtool_files
1418# @USAGE: [--all|--modules]
1419# @DESCRIPTION:
1420# Locate unnecessary libtool files (.la) and libtool static archives
1421# (.a) and remove them from installation image.
1422#
1423# By default, .la files are removed whenever the static linkage can
1424# either be performed using pkg-config or doesn't introduce additional
1425# flags.
1426#
1427# If '--modules' argument is passed, .la files for modules (plugins) are
1428# removed as well. This is usually useful when the package installs
1429# plugins and the plugin loader does not use .la files.
1430#
1431# If '--all' argument is passed, all .la files are removed without
1432# performing any heuristic on them. You shouldn't ever use that,
1433# and instead report a bug in the algorithm instead.
1434#
1435# The .a files are only removed whenever corresponding .la files state
1436# that they should not be linked to, i.e. whenever these files
1437# correspond to plugins.
1438#
1439# Note: if your package installs both static libraries and .pc files
1440# which use variable substitution for -l flags, you need to add
1441# pkg-config to your DEPEND.
1442prune_libtool_files() {
1443 debug-print-function ${FUNCNAME} "$@"
1444
1445 local removing_all removing_modules opt
1446 for opt; do
1447 case "${opt}" in
1448 --all)
1449 removing_all=1
1450 removing_modules=1
1451 ;;
1452 --modules)
1453 removing_modules=1
1454 ;;
1455 *)
1456 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1457 esac
1458 done
1459
1460 local f
1461 local queue=()
1462 while IFS= read -r -d '' f; do # for all .la files
1463 local archivefile=${f/%.la/.a}
1464
1465 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1466 local reason pkgconfig_scanned
1467 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1468
1469 if [[ ${snotlink} == yes ]]; then
1470
1471 # Remove static libs we're not supposed to link against.
1472 if [[ -f ${archivefile} ]]; then
1473 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1474 queue+=( "${archivefile}" )
1475 fi
1476
1477 # The .la file may be used by a module loader, so avoid removing it
1478 # unless explicitly requested.
1479 if [[ ${removing_modules} ]]; then
1480 reason='module'
1481 fi
1482
1483 elif [[ ${snotlink} == no ]]; then
1484
1485 # A valid .la file must have a valid 'shouldnotlink='.
1486 # That assumption helps us avoid removing random files
1487 # which match '*.la', see bug #468380.
1488
1489 # Remove .la files when:
1490 # - user explicitly wants us to remove all .la files,
1491 # - respective static archive doesn't exist,
1492 # - they are covered by a .pc file already,
1493 # - they don't provide any new information (no libs & no flags).
1494
1495 if [[ ${removing_all} ]]; then
1496 reason='requested'
1497 elif [[ ! -f ${archivefile} ]]; then
1498 reason='no static archive'
1499 elif [[ ! $(sed -nre \
1500 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1501 "${f}") ]]; then
1502 reason='no libs & flags'
1503 else
1504 if [[ ! ${pkgconfig_scanned} ]]; then
1505 # Create a list of all .pc-covered libs.
1506 local pc_libs=()
1507 if [[ ! ${removing_all} ]]; then
1508 local pc
1509 local tf=${T}/prune-lt-files.pc
1510 local pkgconf=$(tc-getPKG_CONFIG)
1511
1512 while IFS= read -r -d '' pc; do # for all .pc files
1513 local arg libs
1514
1515 # Use pkg-config if available (and works),
1516 # fallback to sed.
1517 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1518 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1519 libs=$(${pkgconf} --libs "${tf}")
1520 else
1521 libs=$(sed -ne 's/^Libs://p' "${pc}")
1522 fi
1523
1524 for arg in ${libs}; do
1525 if [[ ${arg} == -l* ]]; then
1526 if [[ ${arg} == '*$*' ]]; then
1527 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1528 eqawarn "(arg: ${arg})"
1529 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1530 fi
1531
1532 pc_libs+=( lib${arg#-l}.la )
1533 fi
1534 done
1535 done < <(find "${D}" -type f -name '*.pc' -print0)
1536
1537 rm -f "${tf}"
1538 fi
1539
1540 pkgconfig_scanned=1
1541 fi # pkgconfig_scanned
1542
1543 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1544 fi # removal due to .pc
1545
1546 fi # shouldnotlink==no
1547
1548 if [[ ${reason} ]]; then
1549 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1550 queue+=( "${f}" )
1666 fi 1551 fi
1552 done < <(find "${D}" -xtype f -name '*.la' -print0)
1553
1554 if [[ ${queue[@]} ]]; then
1555 rm -f "${queue[@]}"
1556 fi
1667} 1557}
1558
1559check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1560
1561fi

Legend:
Removed from v.1.223  
changed lines
  Added in v.1.419

  ViewVC Help
Powered by ViewVC 1.1.20